// 
//  dseq.c
//  mivip
//  
//  Created by Maarten Everts.
// 

#include <stdio.h>
#include <stdlib.h>
#include "dseq.h"

#define DSeq_INITIALCAPACITY 128

DSeq *DSeq_new(void)
{
    return (DSeq*)malloc(sizeof(DSeq));
}

void DSeq_setCapacity(DSeq *self, int capacity)
{
    self->capacity = capacity;
    self->items = realloc(self->items,self->itemSize*self->capacity);
}

void DSeq_init(DSeq *self, int itemSize)
{
    DSeq_initWithCapacity(self,itemSize,DSeq_INITIALCAPACITY);
}

void DSeq_initWithCapacity(DSeq *self, int itemSize, int capacity)
{
    self->size = 0;
    self->itemSize = itemSize;
    self->items = NULL;
    DSeq_setCapacity(self,capacity);
}

void *DSeq_addItem(DSeq *self)
{
    if (self->size + 1 > self->capacity) {
        DSeq_setCapacity(self,2*self->capacity);
    }
    void *newItem = DSeq_getItem(self,self->size);
    self->size += 1;
    return newItem;
}

void DSeq_free(DSeq *self)
{
    if (self) {
        if (self->items) {
            free(self->items);
            self->items = NULL;
        }
        self->size = 0;
        self->capacity = 0;
    }
}
