// 
//  lines.h
//  mivip
//  
//  Created by Maarten Everts.
// 
#ifndef LINES_H_17FDKO63
#define LINES_H_17FDKO63

#include "sarray.h"
#include "dseq.h"

typedef SArray Line;

Line *Line_new(void);
void Line_init(Line *self, int numPoints, int dim);
#define Line_initCopy(self,other) SArray_initCopy((self),(other))
void Line_freeData(Line *self);
void Line_free(Line *self);

#define Line_getPoint(self,i) (&(((float*)(self)->data))[((i)*(self)->strides[0])])
#define Line_getNumPoints(self) ((self)->shape[0])
#define Line_DIM 3
#define Line_getAttr(self,i) (&(((float*)(self)->data))[Line_DIM+((i)*(self)->strides[0])])
#define Line_clear(self) (SArray_clear((self)))

typedef DSeq LineSeq;

#define LineSeq_new DSeq_new
void LineSeq_initCopy(LineSeq *self, LineSeq *other);
#define LineSeq_getNumLines(self) ((self)->size)
#define LineSeq_getLine(self,i) ((Line*)(DSeq_getItem((self),(i))))
LineSeq* LineSeq_newFromTemplate(LineSeq *template);
#define LineSeq_init(self) DSeq_init((self),sizeof(Line))
#define LineSeq_initWithCapacity(self,capacity) DSeq_initWithCapacity((self),sizeof(Line),(capacity))
void LineSeq_clear(LineSeq *self);
void LineSeq_free(LineSeq *self);
#define LineSeq_addLine(self) ((Line*)DSeq_addItem((self)))

void LineSeq_printInfo(LineSeq *self);

void LineSeq_addAttributes(LineSeq *self);

// PointArray* PointArray_new(void);
// void PointArray_init(PointArray *self,int numPoints);
// void PointArray_initFromData(PointArray *self,int numPoints,float *data);
// void PointArray_initCopy(PointArray *self, PointArray *other);
// void PointArray_clear(PointArray *self);
// void PointArray_freeData(PointArray *self);
// void PointArray_free(PointArray *self);

#endif /* end of include guard: LINES_H_17FDKO63 */
