// 
//  sarray.h
//  mivip
//  
//  A simple multi-dimensial array data-structure.
//
//  Created by Maarten Everts.
// 
#ifndef SARRAY_H_1U4FL3X3
#define SARRAY_H_1U4FL3X3

#define SArray_MAXDIM 4

typedef struct {
    int nd;
    int shape[SArray_MAXDIM];
    int strides[SArray_MAXDIM];
    int itemSize;
    int ownData;
    void *data;
} SArray;

SArray *SArray_new(void);
void SArray_init(SArray *self, int nd, int *shape, int itemSize);
void SArray_initAsView(SArray *self, int nd, int *shape, int itemSize, void *data);
void SArray_initCopy(SArray *self, SArray *other);
void SArray_clear(SArray *self);
void SArray_freeData(SArray *self);
void SArray_free(SArray *self);
void SArray_printInfo(SArray *self);

#endif /* end of include guard: SARRAY_H_1U4FL3X3 */
