#!/usr/bin/env python
from dataio import sldfile, sopfile, linesfile
import os
import sys
import numpy as np

def main():
    """Simple main"""
    print "lineconv"

    if len(sys.argv) != 3:
        print "Usage: "+sys.argv[0] +" <input> <output>"
        return 1
    else:
        input_filename = sys.argv[1]
        if input_filename.endswith(".sld"):
            linedata = sldfile.read(input_filename)
        elif input_filename.endswith(".sop"):
            linedata = sopfile.read(input_filename)
        elif input_filename.endswith(".lines"):
            header,linedata = linesfile.read(input_filename)
        else:
            print "Error: unsupported input file type."
            return 1
        
        output_filename = sys.argv[2]
        if output_filename.endswith(".sld"):
            sldfile.write(linedata, output_filename)
        elif output_filename.endswith(".sop"):
            sopfile.write(linedata, output_filename)
        elif output_filename.endswith(".lines"):
            linesfile.write(linedata, output_filename)
        else:
            print "Error: unsupported output file type."
            return 1
        

if __name__=='__main__':
    sys.exit(main())
